var path = require('path');
var fs = require('fs');
var env = process.env.NODE_ENV || 'development';
var os = require('os');

var logDir = path.resolve(__dirname, '../logs');
if ( !fs.existsSync( logDir ) ) {
    fs.mkdirSync( logDir );
}

var isOfficialEnv = false;

if (os.hostname() === 'prod-app-98' && os.release() === '3.13.0-86-generic') {
    isOfficialEnv = true;
}

var config = {
    logSettings: {
        level: isOfficialEnv ? 'WARN' : 'DEBUG',
        appenders: [
            {
                type: 'console'
            }, {
                type: 'file',
                filename: logDir + '/bridge.log',
                category: ['bridge', 'console']
            }, {
                type: 'file',
                filename: logDir + '/io.log',
                category: 'io'
            }
        ],
        replaceConsole: true
    },
    fileBaseUrl: env === 'production'
        ? 'https://data-bridge.enhancer.io/file/'
        : 'http://data-bridge.enhancer.cc/file/',
    isOfficialEnv: isOfficialEnv
};

module.exports = config;